﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Interop;
using Tekla.Structures.Model;
using TSG = Tekla.Structures.Geometry3d;

namespace TestFvH
{
    public partial class Form2 : Form
    {
        Model m;
        int x_offset = 1000;
        int y_offset = 1000;
        int z_offset = 1000;

        public Form2()
        {
            InitializeComponent();
        }

        void addBeam(int x1, int y1, int z1, int x2, int y2, int z2, int c)
        {
            Beam myBeam = new Beam(new TSG.Point(x_offset + x1, y_offset + y1, z_offset + z1), new TSG.Point(x_offset + x2, y_offset + y2, z_offset + z2));
            myBeam.Material.MaterialString = "S235JR";
            myBeam.Profile.ProfileString = "400*400";
            myBeam.Finish = "PAINT";
            myBeam.Class = (1 + (c % 14)).ToString();
            myBeam.Insert();
            m.CommitChanges();
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            m = new Model();
            if (!m.GetConnectionStatus())
                MessageBox.Show("Not connected to tekla");


            int max_it = 256;
            double x1 = -2, y1 = -2;
            double x2 = 2, y2 = 2;
            int steps = 100;
            int mul = 100;
            for(int x=0; x<steps; x++)
            {
                for(int y=0; y<steps; y++)
                {
                    double xc = (x2 - x1) / steps * x + x1;
                    double yc = (y2 - y1) / steps * y + y1;
                    double wx = 0;
                    double wy = 0;
                    int it = 0;
                    while (wx * wx + wy * wy < 4 && it < max_it)
                    {
                        double temp = wx * wx - wy * wy + xc;
                        wy = 2 * wx * wy + yc;
                        wx = temp;
                        it++;
                    }

                    if (it < max_it)
                    {
                        addBeam(x * mul, y * mul, 0, (x + 1) * mul, (y + 1) * mul, 0, it);
                    }
                }
            }
        }
    }
}
